"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const insert_if_1 = __importDefault(require("insert-if"));
const ramda_adjunct_1 = require("ramda-adjunct");
const recompose_1 = require("recompose");
const renderWhen_hoc_1 = require("./renderWhen.hoc");
const withLoading_hoc_1 = require("./withLoading.hoc");
const withUpdating_hoc_1 = require("./withUpdating.hoc");
const withAppCreator = ({ loadingComponent, loadingPredicate, updatingStyle }) => ({ updates = [], renderWhen: renderBranches = [] } = {}) => (WrappedComponent) => {
    const loadingOptions = {
        predicate: loadingPredicate,
        component: loadingComponent
    };
    const updateOptions = {
        updates,
        updatingStyle,
        component: loadingComponent
    };
    const enhancers = [
        ...insert_if_1.default(!ramda_adjunct_1.isNilOrEmpty(loadingOptions), withLoading_hoc_1.withLoadingCreator(loadingOptions)),
        ...insert_if_1.default(ramda_adjunct_1.isNonEmptyArray(updates), withUpdating_hoc_1.withUpdatingCreator(updateOptions)),
        ...insert_if_1.default(ramda_adjunct_1.isNonEmptyArray(renderBranches), renderWhen_hoc_1.renderWhen(renderBranches))
    ];
    return recompose_1.compose(...enhancers)(WrappedComponent);
};
exports.withAppCreator = withAppCreator;
